/***************************************************************
* Program: addupdate.p.p
* Author : Steven Lichtenberg 
* Date   : 08/14/2002
* Purpose: Generic routine add and update database records based
*          on a passed temp-table of field/value pairs
* Tables Used:  Generic routine that will work on any table
* Modified: 08/14/2002 SWL initial creation
****************************************************************/ 
def input parameter filnm  as char no-undo.
def input parameter keyfld as char no-undo.
def input parameter reqnum as char no-undo.
def input parameter hdatatab as handle no-undo.

def var hqry    as handle no-undo.
def var hbuf    as handle no-undo.
def var hfield  as handle no-undo.
def var hrecord as handle no-undo.
def var dbfield as handle no-undo.
def var dbqry   as handle no-undo.

def var qrystring as char no-undo.
def var icnt as int no-undo.

create buffer hrecord for table filnm.
hbuf = hdatatab:default-buffer-handle.
create query hqry.
hqry:set-buffers(hbuf).

if reqnum <> "" then 
do:
    qrystring = "For each " + filnm + " exclusive-lock " +
        " where " + keyfld " = ~'" + reqnum + "~'".
    create query dbqry.
    dbqry:set-buffers(hrecord).
    if not dbquery:query-prepare(qrystring) then return qrystring.
    if not dbquery:query-open then return "Could not open query".
    dbquery:get-next.
    if dbquery:query-off-end then hrecord:buffer-create.
end. /* if reqnum <> "" */
else hrecord:buffer-create.
do icnt = 1 to hrecord:num-fields:
    hqry:query-prepare("for each " + hbuf:name " where fieldnm = ~'" +
        hrecord:name + "~'").
    hqry:query-open.
    hqry:get-next.
    if hqry:query-off-end then next.
    assign
        dbfield = hrecord:buffer-field(icnt)
        hfield = hbuf:buffer-field("fieldval")
        dbfield:buffer-value = if hfield:buffer-value ne dbfield:buffer-value
           then hfield:buffer-value else dbfield:buffer-value.
end. /* do icnt = 1 to hrecord:num-fields */