/***************************************************************
* Program: deleterec.p
* Author : Steven Lichtenberg 
* Date   : 02/15/2001
* Purpose: Generic routine to query a table and delete the associated 
*          record(s)
* Tables Used:  Generic routine that will work on any table
* Modified: 11/28/2001 SWL Error reporting added for robustness.
****************************************************************/         
def input parameter v-filnm as char no-undo.
def input parameter v-where as char no-undo.


def var h-buf  as handle no-undo.
def var h-qry  as handle no-undo.

def var wherstr as char no-undo.
def var icnt    as int  no-undo.
def var itmno                as int no-undo.
def var fldnam               as char no-undo.
def var isok                 as log no-undo.
def var i                    as int no-undo.

wherstr = "for each " + v-filnm + " where " +  v-where + " exclusive-lock".

create buffer h-buf for table v-filnm.
create query h-qry.
h-qry:set-buffers(h-buf).     /* assign the buffer to the query */
isok = h-qry:query-prepare(wherstr) no-error. /* assign query string */
if not isok or error-status:error then 
do:
    do i = 1 to 5:
        message error-status:get-message(i).
        {&out} error-status:get-message(i).
    end.    
    return.
end.
isok = h-qry:query-open no-error.
if not isok or error-status:error then
do:
    do i = 1 to 5:
        message error-status:get-message(i).
        {&out} error-status:get-message(i).
    end.    
    return.
end.
if not isok then return.                /* open the query */
repeat transaction:                                 /* copy table contents to the temp-table */
    h-qry:get-next.
    if h-qry:query-off-end then
        leave.         
    h-buf:buffer-delete no-error.
end.  /* repeat */
if error-status:error then return error-status:get-message(1).




